<?php
namespace Teknisa\COZ\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use \Teknisa\Model\Planejamento\Entities\Consplan;

class PrevisaoConsumoCentralService {

	protected $util;
    protected $dataSourceManager;
    protected $environment;
    protected $entityManager;
    protected $novoCodigo;
	
	public function __construct($util, $dataSourceManager, $environment, $entityManager, $novoCodigo) {
        $this->util = $util;
		$this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
		$this->novoCodigo = $novoCodigo;
	}

    public function procedureConsplanGeral($nrlista, $dtinicial, $dtfinal, $cdprodutoini, $cdprodutofin, $idprodutos) {
        $connection = $this->entityManager->getConnection();

        date_default_timezone_set("America/Sao_Paulo");

        $idseprato = 'P';
        $peacrescimo = 0;
        $idarredond = 'N';
        $cdoperador = $this->environment->getCdOperador();
        $nrconsplanth = 'GERANOVCOD';

        $procedure = new StoredProcedure($connection, 'CONSPLAN_GERAL');
        $procedure->addParam(new Param ('P_NRLISTA', Param::PARAM_INPUT, $nrlista, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_DTINICIAL', Param::PARAM_INPUT, $dtinicial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_DTFINAL', Param::PARAM_INPUT, $dtfinal, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_IDPRODUTOS', Param::PARAM_INPUT, $idprodutos, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_IDSEPPRATO', Param::PARAM_INPUT, $idseprato, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_PEACRESCIMO', Param::PARAM_INPUT, $peacrescimo, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_IDARREDOND', Param::PARAM_INPUT, $idarredond, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_CDPRODUTOINI', Param::PARAM_INPUT, $cdprodutoini, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_CDPRODUTOFIN', Param::PARAM_INPUT, $cdprodutofin, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_NRCONSPLANTH', Param::PARAM_INPUT, $nrconsplanth, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_NRCONSPLAN', Param::PARAM_OUTPUT, NULL, Param::PARAM_TYPE_STR, 400));

        return $procedure->execute();
    }

    public function deletaConsplan($nrorg, $nrconsplan) {
        $connection = $this->entityManager->getConnection();
        $query="DELETE FROM CONSPLAN WHERE NRORG = :NRORG AND NRCONSPLAN = :NRCONSPLAN";
        $connection->executeQuery($query, array("NRORG" => $nrorg, "NRCONSPLAN" => $nrconsplan));

        return true;
    }

    public function procedurePrevConsListaPlanprod($cdcentral, $nrlista, $dtinicial, $dtfinal, $cdprodutoini, $cdprodutofin, $produtos) {
        $connection = $this->entityManager->getConnection();

        date_default_timezone_set("America/Sao_Paulo");
        $peacrescimo = 0;
        $idarredond = 'N';
        $cdoperador = $this->environment->getCdOperador();
        
        $procedure = new StoredProcedure($connection, 'PREVISAO_DE_CONSUMO_PLANPROD');
        $procedure->addParam(new Param ('P_CDCENTRAL', Param::PARAM_INPUT, $cdcentral, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_NRLISTAFILI', Param::PARAM_INPUT, $nrlista, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_DTINICIAL', Param::PARAM_INPUT, $dtinicial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_DTFINAL', Param::PARAM_INPUT, $dtfinal, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_CDPRODUTOINI', Param::PARAM_INPUT, $cdprodutoini, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_CDPRODUTOFIN', Param::PARAM_INPUT, $cdprodutofin, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_PEACRESCIMO', Param::PARAM_INPUT, $peacrescimo, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_IDARREDOND', Param::PARAM_INPUT, $idarredond, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_IDEXCL_PREV', Param::PARAM_INPUT, 'S', Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param ('P_IDPRODUTOS', Param::PARAM_INPUT, $produtos, Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
}